#property copyright "Copyright  2005, MetaQuotes Software Corp."
//---- input parameters
extern int Order_Point=10; //        /
extern int SL_Point=50; //  -c
extern int TS1_Point=10; //      -  
extern int TS2_Point=15; //  -
extern double Lots=0.1; //  
extern double TurnLots=0.2; //  -
//+------------------------------------------------------------------+
//| expert initialization function |
//+------------------------------------------------------------------+
int init()
{
//---- 

//----
return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{
//---- 

//----
return(0);
}
//+------------------------------------------------------------------+
//| expert start function |
//+------------------------------------------------------------------+
int start()
{
int total, cnt, OpenOrder, DefOrder, pos;
double max, min, SL;
datetime time;
//---- 

//        
if(Symbol()=="USDCAD")
time=StrToTime("12:00");
else
time=StrToTime("09:00");

//         
total=OrdersTotal();
OpenOrder=0;
DefOrder=0; 
for(cnt=0;cnt<total;cnt++)
{
if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true && OrderSymbol()==Symbol())
{
if(OrderType()==OP_BUY || OrderType()==OP_SELL)
OpenOrder++; //   
else
DefOrder++; //   
}
}

//       
if(TimeHour(CurTime())==TimeHour(time) && TimeMinute(CurTime())<5 && OpenOrder==0 && DefOrder==0)
{
total=24*60/Period()+1;
max=High[0];
min=Low[0];
for(pos=0; pos<total; pos++)
{
if (TimeDayOfYear(Time[pos])==TimeDayOfYear(CurTime()))
{
if(High[pos]>max)
max=High[pos]; //  
if(Low[pos]<min)
min=Low[pos]; //  
}
}
OrderSend(Symbol(),OP_BUYSTOP,Lots,max+Order_Point*Point,3,max-(SL_Point-Order_Point)*Point,0,"BUY Scalping",16384,0,CLR_NONE);
OrderSend(Symbol(),OP_SELLSTOP,Lots,min-Order_Point*Point,3,min+(SL_Point-Order_Point)*Point,0,"SELL Scalping",16384,0,CLR_NONE);
}

//       
//       
if(OpenOrder==1 && DefOrder==1)
{
total=OrdersTotal();
for(cnt=0;cnt<total;cnt++)
{
if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true && OrderSymbol()==Symbol() && OrderMagicNumber()==16384)
{
//     
if(OrderType()==OP_BUY && (Bid-OrderOpenPrice())>(TS1_Point*Point) && OrderStopLoss()<OrderOpenPrice())
OrderModify(OrderTicket(),0,OrderOpenPrice()+1*Point,0,0,CLR_NONE);
if(OrderType()==OP_SELL && (OrderOpenPrice()-Ask)>(TS1_Point*Point) && OrderStopLoss()>OrderOpenPrice())
OrderModify(OrderTicket(),0,OrderOpenPrice()-1*Point,0,0,CLR_NONE);
//   
if(OrderType()==OP_BUY && (Bid-OrderStopLoss())>(TS2_Point*Point) && OrderStopLoss()>OrderOpenPrice())
OrderModify(OrderTicket(),0,Bid-TS2_Point*Point,0,0,CLR_NONE);
if(OrderType()==OP_SELL && (OrderStopLoss()-Ask)>(TS2_Point*Point) && OrderStopLoss()<OrderOpenPrice())
OrderModify(OrderTicket(),0,Ask+TS2_Point*Point,0,0,CLR_NONE);
//   
if(OrderType()==OP_BUYSTOP && OrderLots()==Lots)
{
OrderDelete(OrderTicket());
DefOrder--;
}
if(OrderType()==OP_SELLSTOP && OrderLots()==Lots)
{
OrderDelete(OrderTicket());
DefOrder--;
}
}
}
}

//  - 
if(OpenOrder==1 && DefOrder==0) 
{
total=OrdersTotal();
for(cnt=0;cnt<total;cnt++)
{
if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true && OrderSymbol()==Symbol() && OrderMagicNumber()==16384)
{
if(OrderType()==OP_BUY && OrderLots()==Lots)
{
SL=OrderStopLoss();
OrderSend(Symbol(),OP_SELLSTOP,TurnLots,SL,3,SL+SL_Point*Point,0,"TurnSELL Scalping",16384,0,CLR_NONE);
}
if(OrderType()==OP_SELL && OrderLots()==Lots)
{
SL=OrderStopLoss();
OrderSend(Symbol(),OP_BUYSTOP,TurnLots,SL,3,SL-SL_Point*Point,0,"TurnBUY Scalping",16384,0,CLR_NONE);
}
}
}
}

//        
if(OpenOrder==0 && DefOrder==1)
{
total=OrdersTotal();
for(cnt=0;cnt<total;cnt++)
{
if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true && OrderSymbol()==Symbol() && OrderMagicNumber()==16384 && OrderLots()==TurnLots)
OrderDelete(OrderTicket());
}
}
//----
return(0);
}
//+------------------------------------------------------------------+

